--
-- Time elapsed timer
-- ------------------
-- Author:    Jaroslav Ban
-- Date:      10 Aug 2006
-- Version:   1.00

-- Revision history:
-- -----------------
--
-- Remarks:
-- --------
-- the output is asserted if the counter is allowed
-- to reach N without being reset by 'reset' signal

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_unsigned.all;

ENTITY elapsed IS
  GENERIC (
    log2N   : INTEGER := 5
  );
  PORT (
    start   : IN STD_LOGIC;
    clk     : IN STD_LOGIC;
    timeout : OUT STD_LOGIC
  );
END elapsed;

ARCHITECTURE a OF elapsed IS
  SIGNAL cntr : STD_LOGIC_VECTOR(log2N DOWNTO 0);
BEGIN
  PROCESS (start, clk)
  BEGIN
    IF start = '1' THEN
      cntr <= (others => '0');
    ELSIF rising_edge(clk) THEN
      IF cntr(log2N) = '0' THEN
        cntr <= cntr + 1;
      END IF;
    END IF;
  END PROCESS;
  timeout <= cntr(log2N);
END a;